import java.util.Arrays;

/*ghassanfakher
 * section 6
 */
public class Bank {
	private Account[] accounts;
	public Bank(String fileName)
	{
		In users = new In(fileName);
		int numLines = 0;
		while(!users.isEmpty())
		{
			users.readLine();
			numLines++;
		}
		users = new In(fileName);
		accounts = new Account[numLines];
		for(int i = 0; i < numLines; i++)
		{
			accounts[i] = new Account(users.readInt(), users.readString(), users.readDouble());
		}
	}
	public boolean transfer(int idFrom, int idTo, double balance)
	{
		int idFromPos = checkExistence(idFrom);
		int idToPos = checkExistence(idTo);
		if(idToPos == -1 || idFromPos == -1)
		{
			return false;
		}
		else
		{
			accounts[idToPos].withdraw(balance);
			accounts[idFromPos].deposit(balance);
			return true;
		}
	}
	public boolean close(int id)
	{
		int IDpos = checkExistence(id);
		if(IDpos != -1)
		{
			for(int i = IDpos; i < accounts.length - 1; i++)
			{
				Account temp = accounts[i + 1];
				accounts[i + 1] = accounts[i];
				accounts[i] = temp;
			}
			Account[] newAccounts = new Account[accounts.length - 1];
			for(int i = 0; i < newAccounts.length; i++)
			{
				newAccounts[i] = accounts[i];
			}
			accounts = newAccounts;
			System.out.println(Arrays.toString(accounts));
			return true;
		}
		else
			return false;
	}
	public String toString()
	{
		return Arrays.toString(accounts);
	}
	public boolean open(int id, String name, double balance)
	{
		int IDpos = checkExistence(id);
		
		if(IDpos == -1)
		{
			Account[] newAccounts = new Account[accounts.length + 1];
			for(int i = 0; i < accounts.length; i++)
			{
				newAccounts[i] = accounts[i];
			}	
			newAccounts[newAccounts.length - 1] = new Account(id, name, balance);
			accounts = new Account[newAccounts.length];
			for(int i = 0; i < accounts.length; i++)
			{
				accounts[i] = newAccounts[i];
			}
			return true;
		}	
		else
		{
			return false;
		}
	}
	
	public int checkExistence(int id)
	{
		int IDpos = -1;
		for(int i = 0; i < accounts.length && IDpos == -1; i++)
		{
			if(accounts[i].getID() == id)
			{
				IDpos = i;
			}
		}
		return IDpos;
	}
	public Account getAccount(int id)
	{
		return accounts[checkExistence(id)];
	}
	public static void main(String[] args)
	{
		Bank a = new Bank("accounts.txt");
		System.out.println(a.toString());
		a.close(123);
		a.open(222, "marwan", 500);
		a.open(221, "ghassan", 1);
		System.out.println(a.toString());
	}
}
